/*
 * Intercept.c
 *
 * To use this code you need to rename /dev/ir to
 * /dev/ir_real, mkfifo /dev/ir and put intercept
 * into the startup by moving /sbin/init to /sbin/init.empeg
 * and creating a script called init to call intercept
 * first and then the real init.
 *
 * It will then intercept IR codes and do a beep
 * before passing them onto the player. I have noticed that
 * the beep sometimes lags the press, I suspect the intercept
 * process is being swapped out by the caching facility.
 *
 * Thanks to Mike Crowe @empeg for the dsp ioctl
 *
 * Obviously I take no responsibilty for this mess ;-)
 *
 * Steve Boyle  sysboy@hotmail.com
 *
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <math.h>
#include <sched.h>
#include <sys/mman.h>

#include "ir.h"
#define IR_DEV "/dev/ir"


main(argc,argv)
int argc;
char *argv[];
{
int irreadfd;
int irwritefd;
int verbose;
ssize_t rts;
long ircode;

 verbose=1;

 irreadfd = open(IR_DEV, O_RDONLY&O_NDELAY&O_NONBLOCK);
 if ( irreadfd == -1 ) {
    perror("Opening IR device for reading.");
    exit(1);
 }

for (;;) {

  rts = read(irreadfd, (char *) &ircode, 4);
  if (rts == -1 ) {
    perror("Reading from IR device.");
    close(irreadfd);
    exit(1);
  }

  if (rts == 0 ) {
    perror("Finished reading from IR device.");
    close(irreadfd);
    exit(0);
  }

  fprintf(stderr,"%ld\n",ircode);
 }
close(irreadfd);
}

